Index: binaries/data/mods/public/simulation/components/%UnitAI.js
===================================================================
--- binaries/data/mods/public/simulation/components/%UnitAI.js	(revision 15170)
+++ binaries/data/mods/public/simulation/components/%UnitAI.js	(working copy)
@@ -124,7 +124,7 @@
 };
 
 // See ../helpers/FSM.js for some documentation of this FSM specification syntax
-var UnitFsmSpec = {
+UnitAI.prototype.UnitFsmSpec = {
 
 	// Default event handlers:
 
@@ -552,95 +552,6 @@
 		this.FinishOrder();
 	},
 
-	"Order.Gather": function(msg) {
-		// If the target is still alive, we need to kill it first
-		if (this.MustKillGatherTarget(this.order.data.target))
-		{
-			// Make sure we can attack the target, else we'll get very stuck
-			if (!this.GetBestAttackAgainst(this.order.data.target))
-			{
-				// Oops, we can't attack at all - give up
-				// TODO: should do something so the player knows why this failed
-				this.FinishOrder();
-				return;
-			}
-			// The target was visible when this order was issued,
-			// but could now be invisible again.
-			if (!this.CheckTargetVisible(this.order.data.target))
-			{
-				if (this.order.data.secondTry === undefined)
-				{
-					this.order.data.secondTry = true;
-					this.PushOrderFront("Walk", this.order.data.lastPos);
-				}
-				else
-				{
-					// We couldn't move there, or the target moved away
-					this.FinishOrder();
-				}
-				return;
-			}
-
-			this.PushOrderFront("Attack", { "target": this.order.data.target, "force": false, "hunting": true });
-			return;
-		}
-
-		// Try to move within range
-		if (this.MoveToTargetRange(this.order.data.target, IID_ResourceGatherer))
-		{
-			// We've started walking to the given point
-			this.SetNextState("INDIVIDUAL.GATHER.APPROACHING");
-		}
-		else
-		{
-			// We are already at the target, or can't move at all,
-			// so try gathering it from here.
-			// TODO: need better handling of the can't-reach-target case
-			this.StopMoving();
-			this.SetNextStateAlwaysEntering("INDIVIDUAL.GATHER.GATHERING");
-		}
-	},
-
-	"Order.GatherNearPosition": function(msg) {
-		// Move the unit to the position to gather from.
-		this.MoveToPoint(this.order.data.x, this.order.data.z);
-		this.SetNextState("INDIVIDUAL.GATHER.WALKING");
-	},
-
-	"Order.ReturnResource": function(msg) {
-		// Check if the dropsite is already in range
-		if (this.CheckTargetRange(this.order.data.target, IID_ResourceGatherer) && this.CanReturnResource(this.order.data.target, true))
-		{
-			var cmpResourceDropsite = Engine.QueryInterface(this.order.data.target, IID_ResourceDropsite);
-			if (cmpResourceDropsite)
-			{
-				// Dump any resources we can
-				var dropsiteTypes = cmpResourceDropsite.GetTypes();
-
-				Engine.QueryInterface(this.entity, IID_ResourceGatherer).CommitResources(dropsiteTypes);
-
-				// Our next order should always be a Gather,
-				// so just switch back to that order
-				this.FinishOrder();
-				return;
-			}
-		}
-		// Try to move to the dropsite
-		if (this.MoveToTargetRange(this.order.data.target, IID_ResourceGatherer))
-		{
-			// We've started walking to the target
-			this.SetNextState("INDIVIDUAL.RETURNRESOURCE.APPROACHING");
-			return;
-		}
-		// Oops, we can't reach the dropsite.
-		// Maybe we should try to pick another dropsite, to find an
-		// accessible one?
-		// For now, just give up.
-		this.StopMoving();
-		this.FinishOrder();
-		return;
-	},
-
 	"Order.Trade": function(msg) {
 		// We must check if this trader has both markets in case it was a back-to-work order
 		var cmpTrader = Engine.QueryInterface(this.entity, IID_Trader);
@@ -871,65 +782,6 @@
 			this.SetNextState("GARRISON.GARRISONING");
 		},
 
-		"Order.Gather": function(msg) {
-			if (this.MustKillGatherTarget(msg.data.target))
-			{
-				// The target was visible when this order was given,
-				// but could now be invisible.
-				if (!this.CheckTargetVisible(msg.data.target))
-				{
-					if (msg.data.secondTry === undefined)
-					{
-						msg.data.secondTry = true;
-						this.PushOrderFront("Walk", msg.data.lastPos);
-					}
-					else
-					{
-						// We couldn't move there, or the target moved away
-						this.FinishOrder();
-					}
-					return;
-				}
-
-				this.PushOrderFront("Attack", { "target": msg.data.target, "hunting": true });
-				return;
-			}
-
-			// TODO: on what should we base this range?
-			// Check if we are already in range, otherwise walk there
-			if (!this.CheckTargetRangeExplicit(msg.data.target, 0, 10))
-			{
-				if (!this.CanGather(msg.data.target) || !this.CheckTargetVisible(msg.data.target))
-					// The target isn't gatherable or not visible any more.
-					this.FinishOrder();
-				// TODO: Should we issue a gather-near-position order
-				// if the target isn't gatherable/doesn't exist anymore?
-				else
-					// Out of range; move there in formation
-					this.PushOrderFront("WalkToTargetRange", { "target": msg.data.target, "min": 0, "max": 10 });
-				return;
-			}
-
-			this.CallMemberFunction("Gather", [msg.data.target, false]);
-
-			this.SetNextStateAlwaysEntering("MEMBER");
-		},
-
-		"Order.GatherNearPosition": function(msg) {
-			// TODO: on what should we base this range?
-			// Check if we are already in range, otherwise walk there
-			if (!this.CheckPointRangeExplicit(msg.data.x, msg.data.z, 0, 20))
-			{
-				// Out of range; move there in formation
-				this.PushOrderFront("WalkToPointRange", { "x": msg.data.x, "z": msg.data.z, "min": 0, "max": 20 });
-				return;
-			}
-
-			this.CallMemberFunction("GatherNearPosition", [msg.data.x, msg.data.z, msg.data.type, msg.data.template, false]);
-
-			this.SetNextStateAlwaysEntering("MEMBER");
-		},
-
 		"Order.Heal": function(msg) {
 			// TODO: on what should we base this range?
 			// Check if we are already in range, otherwise walk there
@@ -968,25 +820,6 @@
 			this.SetNextStateAlwaysEntering("MEMBER");
 		},
 
-		"Order.ReturnResource": function(msg) {
-			// TODO: on what should we base this range?
-			// Check if we are already in range, otherwise walk there
-			if (!this.CheckTargetRangeExplicit(msg.data.target, 0, 10))
-			{
-				if (!this.TargetIsAlive(msg.data.target) || !this.CheckTargetVisible(msg.data.target))
-					// The target was destroyed
-					this.FinishOrder();
-				else
-					// Out of range; move there in formation
-					this.PushOrderFront("WalkToTargetRange", { "target": msg.data.target, "min": 0, "max": 10 });
-				return;
-			}
-
-			this.CallMemberFunction("ReturnResource", [msg.data.target, false]);
-
-			this.SetNextStateAlwaysEntering("MEMBER");
-		},
-
 		"Order.Pack": function(msg) {
 			this.CallMemberFunction("Pack", [false]);
 
@@ -1969,369 +1802,6 @@
 			},
 		},
 
-		"GATHER": {
-			"APPROACHING": {
-				"enter": function() {
-					this.SelectAnimation("move");
-
-					this.gatheringTarget = this.order.data.target;	// temporary, deleted in "leave".
-
-					// check that we can gather from the resource we're supposed to gather from.
-					var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
-					var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
-					if (!cmpSupply || !cmpSupply.AddGatherer(cmpOwnership.GetOwner(), this.entity))
-					{
-						// Save the current order's data in case we need it later
-						var oldType = this.order.data.type;
-						var oldTarget = this.order.data.target;
-						var oldTemplate = this.order.data.template;
-
-						// Try the next queued order if there is any
-						if (this.FinishOrder())
-							return true;
-						
-						// Try to find another nearby target of the same specific type
-						// Also don't switch to a different type of huntable animal
-						var nearby = this.FindNearbyResource(function (ent, type, template) {
-							return (
-								ent != oldTarget
-								 && ((type.generic == "treasure" && oldType.generic == "treasure")
-								 || (type.specific == oldType.specific
-								 && (type.specific != "meat" || oldTemplate == template)))
-							);
-						});
-						if (nearby)
-						{
-							this.PerformGather(nearby, false, false);
-							return true;
-						}
-						else
-						{
-							// It's probably better in this case, to avoid units getting stuck around a dropsite
-							// in a "Target is far away, full, nearby are no good resources, return to dropsite" loop
-							// to order it to GatherNear the resource position.
-							var cmpPosition = Engine.QueryInterface(this.gatheringTarget, IID_Position);
-							if (cmpPosition)
-							{
-								var pos = cmpPosition.GetPosition();
-								this.GatherNearPosition(pos.x, pos.z, oldType, oldTemplate);
-								return true;
-							} else {
-								// we're kind of stuck here. Return resource.
-								var nearby = this.FindNearestDropsite(oldType.generic);
-								if (nearby)
-								{
-									this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
-									return true;
-								}
-							}
-						}
-						return true;
-					}
-					return false;
-				},
-
-				"MoveCompleted": function(msg) {
-					if (msg.data.error)
-					{
-						// We failed to reach the target
-
-						// remove us from the list of entities gathering from Resource.
-						var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
-						var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
-						if (cmpSupply && cmpOwnership)
-							cmpSupply.RemoveGatherer(this.entity, cmpOwnership.GetOwner());
-						else if (cmpSupply)
-							cmpSupply.RemoveGatherer(this.entity);
-
-						// Save the current order's data in case we need it later
-						var oldType = this.order.data.type;
-						var oldTarget = this.order.data.target;
-						var oldTemplate = this.order.data.template;
-
-						// Try the next queued order if there is any
-						if (this.FinishOrder())
-							return;
-
-						// Try to find another nearby target of the same specific type
-						// Also don't switch to a different type of huntable animal
-						var nearby = this.FindNearbyResource(function (ent, type, template) {
-							return (
-								ent != oldTarget
-								&& ((type.generic == "treasure" && oldType.generic == "treasure")
-								|| (type.specific == oldType.specific
-								&& (type.specific != "meat" || oldTemplate == template)))
-							);
-						});
-						if (nearby)
-						{
-							this.PerformGather(nearby, false, false);
-							return;
-						}
-
-						// Couldn't find anything else. Just try this one again,
-						// maybe we'll succeed next time
-						this.PerformGather(oldTarget, false, false);
-						return;
-					}
-
-					// We reached the target - start gathering from it now
-					this.SetNextState("GATHERING");
-				},
-				
-				"leave": function() {
-					// don't use ownership because this is called after a conversion/resignation
-					// and the ownership would be invalid then.
-					var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
-					if (cmpSupply)
-						cmpSupply.RemoveGatherer(this.entity);
-					delete this.gatheringTarget;
-				},
-			},
-			
-			// Walking to a good place to gather resources near, used by GatherNearPosition
-			"WALKING": {
-				"enter": function() {
-					this.SelectAnimation("move");
-				},
-
-				"MoveCompleted": function(msg) {
-					var resourceType = this.order.data.type;
-					var resourceTemplate = this.order.data.template;
-
-					// Try to find another nearby target of the same specific type
-					// Also don't switch to a different type of huntable animal
-					var nearby = this.FindNearbyResource(function (ent, type, template) {
-						return (
-							(type.generic == "treasure" && resourceType.generic == "treasure")
-							|| (type.specific == resourceType.specific
-							&& (type.specific != "meat" || resourceTemplate == template))
-						);
-					});
-
-					// If there is a nearby resource start gathering
-					if (nearby)
-					{
-						this.PerformGather(nearby, false, false);
-						return;
-					}
-
-					// Couldn't find nearby resources, so give up
-					if (this.FinishOrder())
-						return;
-
-					// Nothing better to do: go back to dropsite
-					var nearby = this.FindNearestDropsite(resourceType.generic);
-					if (nearby)
-					{
-						this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
-						return;
-					}
-
-					// No dropsites, just give up
-				},
-			},
-
-			"GATHERING": {
-				"enter": function() {
-					this.gatheringTarget = this.order.data.target;	// deleted in "leave".
-
-					// Check if the resource is full.
-					if (this.gatheringTarget)
-					{
-						// Check that we can gather from the resource we're supposed to gather from.
-						// Will only be added if we're not already in.
-						var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
-						var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
-						if (!cmpSupply || !cmpSupply.AddGatherer(cmpOwnership.GetOwner(), this.entity))
-						{
-							this.gatheringTarget = INVALID_ENTITY;
-							this.StartTimer(0);
-							return false;
-						}
-					}
-
-					// If this order was forced, the player probably gave it, but now we've reached the target
-					//	switch to an unforced order (can be interrupted by attacks)
-					this.order.data.force = false;
-					this.order.data.autoharvest = true;
-
-					// Calculate timing based on gather rates
-					// This allows the gather rate to control how often we gather, instead of how much.
-					var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
-					var rate = cmpResourceGatherer.GetTargetGatherRate(this.gatheringTarget);
-
-					if (!rate)
-					{
-						// Try to find another target if the current one stopped existing
-						if (!Engine.QueryInterface(this.gatheringTarget, IID_Identity))
-						{
-							// Let the Timer logic handle this
-							this.StartTimer(0);
-							return false;
-						}
-
-						// No rate, give up on gathering
-						this.FinishOrder();
-						return true;
-					}
-
-					// Scale timing interval based on rate, and start timer
-					// The offset should be at least as long as the repeat time so we use the same value for both.
-					var offset = 1000/rate;
-					var repeat = offset;
-					this.StartTimer(offset, repeat);
-
-					// We want to start the gather animation as soon as possible,
-					// but only if we're actually at the target and it's still alive
-					// (else it'll look like we're chopping empty air).
-					// (If it's not alive, the Timer handler will deal with sending us
-					// off to a different target.)
-					if (this.CheckTargetRange(this.gatheringTarget, IID_ResourceGatherer))
-					{
-						var typename = "gather_" + this.order.data.type.specific;
-						this.SelectAnimation(typename, false, 1.0, typename);
-					}
-					return false;
-				},
-
-				"leave": function() {
-					this.StopTimer();
-
-					// don't use ownership because this is called after a conversion/resignation
-					// and the ownership would be invalid then.
-					var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
-					if (cmpSupply)
-						cmpSupply.RemoveGatherer(this.entity);
-					delete this.gatheringTarget;
-
-					// Show the carried resource, if we've gathered anything.
-					this.SetGathererAnimationOverride();
-				},
-
-				"Timer": function(msg) {
-					var resourceTemplate = this.order.data.template;
-					var resourceType = this.order.data.type;
-
-					var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
-					if (!cmpOwnership)
-						return;
-
-					var cmpSupply = Engine.QueryInterface(this.gatheringTarget, IID_ResourceSupply);
-					if (cmpSupply && cmpSupply.IsAvailable(cmpOwnership.GetOwner(), this.entity))
-					{
-						// Check we can still reach and gather from the target
-						if (this.CheckTargetRange(this.gatheringTarget, IID_ResourceGatherer) && this.CanGather(this.gatheringTarget))
-						{
-							// Gather the resources:
-
-							var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
-
-							// Try to gather treasure
-							if (cmpResourceGatherer.TryInstantGather(this.gatheringTarget))
-								return;
-
-							// If we've already got some resources but they're the wrong type,
-							// drop them first to ensure we're only ever carrying one type
-							if (cmpResourceGatherer.IsCarryingAnythingExcept(resourceType.generic))
-								cmpResourceGatherer.DropResources();
-
-							// Collect from the target
-							var status = cmpResourceGatherer.PerformGather(this.gatheringTarget);
-
-							// If we've collected as many resources as possible,
-							// return to the nearest dropsite
-							if (status.filled)
-							{
-								var nearby = this.FindNearestDropsite(resourceType.generic);
-								if (nearby)
-								{
-									// (Keep this Gather order on the stack so we'll
-									// continue gathering after returning)
-									this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
-									return;
-								}
-
-								// Oh no, couldn't find any drop sites. Give up on gathering.
-								this.FinishOrder();
-								return;
-							}
-
-							// We can gather more from this target, do so in the next timer
-							if (!status.exhausted)
-								return;
-						}
-						else
-						{
-							// Try to follow the target
-							if (this.MoveToTargetRange(this.gatheringTarget, IID_ResourceGatherer))
-							{
-								this.SetNextState("APPROACHING");
-								return;
-							}
-
-							// Can't reach the target, or it doesn't exist any more
-
-							// We want to carry on gathering resources in the same area as
-							// the old one. So try to get close to the old resource's
-							// last known position
-
-							var maxRange = 8; // get close but not too close
-							if (this.order.data.lastPos &&
-								this.MoveToPointRange(this.order.data.lastPos.x, this.order.data.lastPos.z,
-									0, maxRange))
-							{
-								this.SetNextState("APPROACHING");
-								return;
-							}
-						}
-					}
-
-					// We're already in range, can't get anywhere near it or the target is exhausted.
-
-					var herdPos = this.order.data.initPos;
-
-					// Give up on this order and try our next queued order
-					if (this.FinishOrder())
-						return;
-
-					// No remaining orders - pick a useful default behaviour
-
-					// Try to find a new resource of the same specific type near our current position:
-					// Also don't switch to a different type of huntable animal
-					var nearby = this.FindNearbyResource(function (ent, type, template) {
-						return (
-							(type.generic == "treasure" && resourceType.generic == "treasure")
-							|| (type.specific == resourceType.specific
-							&& (type.specific != "meat" || resourceTemplate == template))
-						);
-					});
-					if (nearby)
-					{
-						this.PerformGather(nearby, false, false);
-						return;
-					}
-
-					// If hunting, try to go to the initial herd position to see if we are more lucky
-					if (herdPos)
-						this.GatherNearPosition(herdPos.x, herdPos.z, resourceType, resourceTemplate);
-
-					// Nothing else to gather - if we're carrying anything then we should
-					// drop it off, and if not then we might as well head to the dropsite
-					// anyway because that's a nice enough place to congregate and idle
-
-					var nearby = this.FindNearestDropsite(resourceType.generic);
-					if (nearby)
-					{
-						this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
-						return;
-					}
-					
-					// No dropsites - just give up
-				},
-			},
-		},
-
 		"HEAL": {
 			"Attacked": function(msg) {
 				// If we stand ground we will rather die than flee
@@ -2466,60 +1936,6 @@
 			},  
 		},
 
-		// Returning to dropsite
-		"RETURNRESOURCE": {
-			"APPROACHING": {
-				"enter": function () {
-					this.SelectAnimation("move");
-				},
-
-				"MoveCompleted": function() {
-					// Switch back to idle animation to guarantee we won't
-					// get stuck with the carry animation after stopping moving
-					this.SelectAnimation("idle");
-
-					// Check the dropsite is in range and we can return our resource there
-					// (we didn't get stopped before reaching it)
-					if (this.CheckTargetRange(this.order.data.target, IID_ResourceGatherer) && this.CanReturnResource(this.order.data.target, true))
-					{
-						var cmpResourceDropsite = Engine.QueryInterface(this.order.data.target, IID_ResourceDropsite);
-						if (cmpResourceDropsite)
-						{
-							// Dump any resources we can
-							var dropsiteTypes = cmpResourceDropsite.GetTypes();
-
-							var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
-							cmpResourceGatherer.CommitResources(dropsiteTypes);
-
-							// Stop showing the carried resource animation.
-							this.SetGathererAnimationOverride();
-
-							// Our next order should always be a Gather,
-							// so just switch back to that order
-							this.FinishOrder();
-							return;
-						}
-					}
-
-					// The dropsite was destroyed, or we couldn't reach it, or ownership changed
-					// Look for a new one.
-
-					var cmpResourceGatherer = Engine.QueryInterface(this.entity, IID_ResourceGatherer);
-					var genericType = cmpResourceGatherer.GetMainCarryingType();
-					var nearby = this.FindNearestDropsite(genericType);
-					if (nearby)
-					{
-						this.FinishOrder();
-						this.PushOrderFront("ReturnResource", { "target": nearby, "force": false });
-						return;
-					}
-
-					// Oh no, couldn't find any drop sites. Give up on returning.
-					this.FinishOrder();
-				},
-			},
-		},
-
 		"TRADE": {
 			"Attacked": function(msg) {
 				// Ignore attack
@@ -3091,8 +2507,6 @@
 	},
 };
 
-var UnitFsm = new FSM(UnitFsmSpec);
-
 UnitAI.prototype.Init = function()
 {
 	this.orderQueue = []; // current order is at the front of the list
@@ -3225,11 +2639,11 @@
 UnitAI.prototype.OnCreate = function()
 {
 	if (this.IsAnimal())
-		UnitFsm.Init(this, "ANIMAL.FEEDING");
+		this.UnitFsm.Init(this, "ANIMAL.FEEDING");
 	else if (this.IsFormationController())
-		UnitFsm.Init(this, "FORMATIONCONTROLLER.IDLE");
+		this.UnitFsm.Init(this, "FORMATIONCONTROLLER.IDLE");
 	else
-		UnitFsm.Init(this, "INDIVIDUAL.IDLE");
+		this.UnitFsm.Init(this, "INDIVIDUAL.IDLE");
 };
 
 UnitAI.prototype.OnDiplomacyChanged = function(msg)
@@ -3249,7 +2663,7 @@
 		// Switch to a virgin state to let states execute their leave handlers.
 		var index = this.GetCurrentState().indexOf(".");
 		if (index != -1)
-			UnitFsm.SwitchToNextState(this, this.GetCurrentState().slice(0,index));
+			this.UnitFsm.SwitchToNextState(this, this.GetCurrentState().slice(0,index));
 
 		this.SetStance(this.template.DefaultStance);
 		if(!this.isGarrisoned)
@@ -3260,7 +2674,7 @@
 UnitAI.prototype.OnDestroy = function()
 {
 	// Switch to an empty state to let states execute their leave handlers.
-	UnitFsm.SwitchToNextState(this, "");
+	this.UnitFsm.SwitchToNextState(this, "");
 
 	// Clean up range queries
 	var rangeMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_RangeManager);
@@ -3302,7 +2716,7 @@
 		if (this.orderQueue[i].type == "PickupUnit" && this.orderQueue[i].data.target == msg.entity)
 		{
 			if (i == 0)
-				UnitFsm.ProcessMessage(this, {"type": "PickupCanceled", "data": msg});
+				this.UnitFsm.ProcessMessage(this, {"type": "PickupCanceled", "data": msg});
 			else
 				this.orderQueue.splice(i, 1);
 			break;
@@ -3401,7 +2815,7 @@
 
 UnitAI.prototype.SetNextState = function(state)
 {
-	UnitFsm.SetNextState(this, state);
+	this.UnitFsm.SetNextState(this, state);
 };
 
 // This will make sure that the state is always entered even if this means leaving it and reentering it
@@ -3408,17 +2822,17 @@
 // This is so that a state can be reinitialized with new order data without having to switch to an intermediate state
 UnitAI.prototype.SetNextStateAlwaysEntering = function(state)
 {
-	UnitFsm.SetNextStateAlwaysEntering(this, state);
+	this.UnitFsm.SetNextStateAlwaysEntering(this, state);
 };
 
 UnitAI.prototype.DeferMessage = function(msg)
 {
-	UnitFsm.DeferMessage(this, msg);
+	this.UnitFsm.DeferMessage(this, msg);
 };
 
 UnitAI.prototype.GetCurrentState = function()
 {
-	return UnitFsm.GetCurrentState(this);
+	return this.UnitFsm.GetCurrentState(this);
 };
 
 UnitAI.prototype.FsmStateNameChanged = function(state)
@@ -3447,7 +2861,7 @@
 
 	if (this.orderQueue.length)
 	{
-		var ret = UnitFsm.ProcessMessage(this,
+		var ret = this.UnitFsm.ProcessMessage(this,
 			{"type": "Order."+this.order.type, "data": this.order.data}
 		);
 
@@ -3501,7 +2915,7 @@
 	if (this.orderQueue.length == 1)
 	{
 		this.order = order;
-		var ret = UnitFsm.ProcessMessage(this,
+		var ret = this.UnitFsm.ProcessMessage(this,
 			{"type": "Order."+this.order.type, "data": this.order.data}
 		);
 
@@ -3537,7 +2951,7 @@
 	{
 		this.orderQueue.unshift(order);
 		this.order = order;
-		var ret = UnitFsm.ProcessMessage(this,
+		var ret = this.UnitFsm.ProcessMessage(this,
 			{"type": "Order."+this.order.type, "data": this.order.data}
 		);
 
@@ -3738,7 +3152,7 @@
 		this.timer = undefined;
 	}
 
-	UnitFsm.ProcessMessage(this, {"type": "Timer", "data": data, "lateness": lateness});
+	this.UnitFsm.ProcessMessage(this, {"type": "Timer", "data": data, "lateness": lateness});
 };
 
 /**
@@ -3779,11 +3193,11 @@
 {
 	if (msg.starting && !msg.error)
 	{
-		UnitFsm.ProcessMessage(this, {"type": "MoveStarted", "data": msg});
+		this.UnitFsm.ProcessMessage(this, {"type": "MoveStarted", "data": msg});
 	}
 	else if (!msg.starting || msg.error)
 	{
-		UnitFsm.ProcessMessage(this, {"type": "MoveCompleted", "data": msg});
+		this.UnitFsm.ProcessMessage(this, {"type": "MoveCompleted", "data": msg});
 	}
 };
 
@@ -3792,7 +3206,7 @@
 	// TODO: This is a bit inefficient since every unit listens to every
 	// construction message - ideally we could scope it to only the one we're building
 
-	UnitFsm.ProcessMessage(this, {"type": "ConstructionFinished", "data": msg});
+	this.UnitFsm.ProcessMessage(this, {"type": "ConstructionFinished", "data": msg});
 };
 
 UnitAI.prototype.OnGlobalEntityRenamed = function(msg)
@@ -3811,30 +3225,30 @@
 
 UnitAI.prototype.OnAttacked = function(msg)
 {
-	UnitFsm.ProcessMessage(this, {"type": "Attacked", "data": msg});
+	this.UnitFsm.ProcessMessage(this, {"type": "Attacked", "data": msg});
 };
 
 UnitAI.prototype.OnGuardedAttacked = function(msg)
 {
-	UnitFsm.ProcessMessage(this, {"type": "GuardedAttacked", "data": msg.data});
+	this.UnitFsm.ProcessMessage(this, {"type": "GuardedAttacked", "data": msg.data});
 };
 
 UnitAI.prototype.OnHealthChanged = function(msg)
 {
-	UnitFsm.ProcessMessage(this, {"type": "HealthChanged", "from": msg.from, "to": msg.to});
+	this.UnitFsm.ProcessMessage(this, {"type": "HealthChanged", "from": msg.from, "to": msg.to});
 };
 
 UnitAI.prototype.OnRangeUpdate = function(msg)
 {
 	if (msg.tag == this.losRangeQuery)
-		UnitFsm.ProcessMessage(this, {"type": "LosRangeUpdate", "data": msg});
+		this.UnitFsm.ProcessMessage(this, {"type": "LosRangeUpdate", "data": msg});
 	else if (msg.tag == this.losHealRangeQuery)
-		UnitFsm.ProcessMessage(this, {"type": "LosHealRangeUpdate", "data": msg});
+		this.UnitFsm.ProcessMessage(this, {"type": "LosHealRangeUpdate", "data": msg});
 };
 
 UnitAI.prototype.OnPackFinished = function(msg)
 {
-	UnitFsm.ProcessMessage(this, {"type": "PackFinished", "packed": msg.packed});
+	this.UnitFsm.ProcessMessage(this, {"type": "PackFinished", "packed": msg.packed});
 };
 
 //// Helper functions to be called by the FSM ////
@@ -3890,82 +3304,6 @@
 };
 
 /**
- * Returns the entity ID of the nearest resource supply where the given
- * filter returns true, or undefined if none can be found.
- * TODO: extend this to exclude resources that already have lots of
- * gatherers.
- */
-UnitAI.prototype.FindNearbyResource = function(filter)
-{
-	var range = 64; // TODO: what's a sensible number?
-
-	var playerMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_PlayerManager);
-	// We accept resources owned by Gaia or any player
-	var players = [0];
-	for (var i = 1; i < playerMan.GetNumPlayers(); ++i)
-		players.push(i);
-
-	var cmpTemplateManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_TemplateManager);
-	var cmpRangeManager = Engine.QueryInterface(SYSTEM_ENTITY, IID_RangeManager);
-	var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
-	var nearby = cmpRangeManager.ExecuteQuery(this.entity, 0, range, players, IID_ResourceSupply);
-	for each (var ent in nearby)
-	{
-		if (!this.CanGather(ent))
-			continue;
-		var cmpResourceSupply = Engine.QueryInterface(ent, IID_ResourceSupply);
-		var type = cmpResourceSupply.GetType();
-		var amount = cmpResourceSupply.GetCurrentAmount();
-		var template = cmpTemplateManager.GetCurrentTemplateName(ent);
-
-		// Remove "resource|" prefix from template names, if present.
-		if (template.indexOf("resource|") != -1)
-			template = template.slice(9);
-
-		if (amount > 0 && cmpResourceSupply.IsAvailable(cmpOwnership.GetOwner(), this.entity) && filter(ent, type, template))
-			return ent;
-	}
-
-	return undefined;
-};
-
-/**
- * Returns the entity ID of the nearest resource dropsite that accepts
- * the given type, or undefined if none can be found.
- */
-UnitAI.prototype.FindNearestDropsite = function(genericType)
-{
-	// Find dropsites owned by this unit's player
-	var players = [];
-	var cmpOwnership = Engine.QueryInterface(this.entity, IID_Ownership);
-	if (cmpOwnership)
-		players = [cmpOwnership.GetOwner()];
-
-	// Ships are unable to reach land dropsites and shouldn't attempt to do so.
-	var excludeLand = Engine.QueryInterface(this.entity, IID_Identity).HasClass("Ship");
-
-	var rangeMan = Engine.QueryInterface(SYSTEM_ENTITY, IID_RangeManager);
-	var nearby = rangeMan.ExecuteQuery(this.entity, 0, -1, players, IID_ResourceDropsite);
-	if (excludeLand)
-	{
-		nearby = nearby.filter( function(e) {
-			return Engine.QueryInterface(e, IID_Identity).HasClass("Naval");
-		});
-	}
-
-	for each (var ent in nearby)
-	{
-		var cmpDropsite = Engine.QueryInterface(ent, IID_ResourceDropsite);
-		if (!cmpDropsite.AcceptsType(genericType))
-			continue;
-
-		return ent;
-	}
-
-	return undefined;
-};
-
-/**
  * Returns the entity ID of the nearest building that needs to be constructed,
  * or undefined if none can be found close enough.
  */
@@ -4629,7 +3967,7 @@
 
 	// If we were removed from a formation, let the FSM switch back to INDIVIDUAL
 	if (ent == INVALID_ENTITY)
-		UnitFsm.ProcessMessage(this, { "type": "FormationLeave" });
+		this.UnitFsm.ProcessMessage(this, { "type": "FormationLeave" });
 };
 
 UnitAI.prototype.GetFormationController = function()
@@ -4806,7 +4144,7 @@
 		return;
 
 	if (this.order.type == "Guard")
-		UnitFsm.ProcessMessage(this, {"type": "RemoveGuard"});
+		this.UnitFsm.ProcessMessage(this, {"type": "RemoveGuard"});
 	else
 		for (var i = 1; i < this.orderQueue.length; ++i)
 			if (this.orderQueue[i].type == "Guard")
